IMPLEMENTATION MODULE CookShr;

IMPORT FIO,IO;
FROM Lib IMPORT QSort,CompareProc,Move,HSort;
FROM Str IMPORT Compare,Copy,CHARSET,Append,ItemS;
FROM CoreEFIO IMPORT Wr16,Wr24,Wr32,Rd16,Rd32;
FROM ELib IMPORT ChangeExtension;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
FROM CoreCrt IMPORT WhereX,GotoXY,WhereY;
FROM MLib IMPORT ChangeFName,FDate;
FROM DJArc IMPORT Unpacker;
FROM StopWatch IMPORT StartStopWatch,LookStopWatch;


CONST HiNr=16382;
      HiStr=40;
      Kill= CHARSET{CHR(13),CHR(10)};

TYPE Str70=ARRAY[0..HiStr-1] OF CHAR;
     Str70Ptr=POINTER TO Str70;
     BigArr=ARRAY[0..HiNr] OF Str70Ptr;

     RecPos=ARRAY[0..HiNr] OF LONGCARD;
     RecSiz=ARRAY[0..HiNr] OF CARDINAL;
     FRecPtr=POINTER TO RecPos;
     FRecSizePtr=POINTER TO RecSiz;
     BigPtr= POINTER TO BigArr;

VAR
    Big      : BigPtr;
    FPos     : FRecPtr;
    FSize    : FRecSizePtr;
    Pt,Pt2   : BufferP;
    TwirCount: CARDINAL;
    TwirNr   : CARDINAL;
    MainBuf,MainBuf2  : ARRAY[0..4095] OF BYTE;

CONST TwirlStr="\/";

PROCEDURE Twirly;

BEGIN
 INC (TwirCount);
 IF (TwirCount AND TwirMask)=0 THEN
  INC(TwirNr);
  GotoXY(WhereX()-1,WhereY());
  IO.WrChar(TwirlStr[TwirNr AND 3]);
  END;
END Twirly;

PROCEDURE KillTwir;

BEGIN
 GotoXY(WhereX()-1,WhereY());
 IO.WrChar(" ");
END KillTwir;

PROCEDURE EndStopWatch;

VAR Time : LONGCARD;
    A,C : CARDINAL;

BEGIN
 IO.WrStr("Sorting ");
 IO.WrCard(NoRec,0); IO.WrStr(" jokes took ");
 Time:=LookStopWatch(C);
 IF Time>60 THEN
  A:=CARDINAL(Time DIV 60);
  IO.WrCard(A,0); IO.WrStr(" minutes, ");
  Time:=Time MOD 60;
  END;
 IO.WrLngCard(Time,0); IO.WrChar(".");
 IF C<10 THEN
  IO.WrChar("0");
  END;
 IO.WrCard(C,0); IO.WrStr(" seconds"); IO.WrLn;
END EndStopWatch;

VAR CurPos : LONGCARD;
    Fl     : BOOLEAN;

PROCEDURE CmpName(A,B : CARDINAL):BOOLEAN;
BEGIN
 Twirly;
 Fl:=(Big^[A-1]^[0]=CHR("#"));
 IF Big^[B-1]^[0]=CHR("#") THEN
  IF Fl THEN
   IF Big^[A-1]^[1]#" " THEN
    RETURN TRUE;
   ELSE
    RETURN FALSE;
    END;
  ELSE
   RETURN FALSE;
   END;
  END;
 IF Fl THEN
  RETURN TRUE;
  END;
 RETURN (Compare(Big^[A-1]^,Big^[B-1]^)<0)
END CmpName;

PROCEDURE CmpSize(A,B : CARDINAL):BOOLEAN;
BEGIN
 Twirly;
 IF Big^[A-1]^[0]=CHR("#") THEN
  RETURN TRUE;
 ELSE
  RETURN FSize^[A-1]<FSize^[B-1]
  END;
END CmpSize;

PROCEDURE Swp(A,B:CARDINAL);

VAR S : ARRAY[0..90] OF CHAR;
    FP :LONGCARD;
    Si : CARDINAL;

BEGIN
 Si:=FSize^[A-1];    FSize^[A-1]:=FSize^[B-1];     FSize^[B-1]:=Si;
 FP:=FPos^[A-1];     FPos^[A-1]:=FPos^[B-1];       FPos^[B-1]:=FP;
 Copy(S,Big^[A-1]^); Copy(Big^[A-1]^,Big^[B-1]^);  Copy (Big^[B-1]^,S);
END Swp;

PROCEDURE ReadRecord(FIn:FIO.File);

VAR C : CHAR;

BEGIN
 C:=FIO.RdChar(FIn);
 ThisBuf^[0]:=CHR(C);
 ThisPnt:=1;
 LOOP
  C:=FIO.RdChar(FIn);
  IF C=CHR(1) THEN
   C:=CHR(32);
   END;
  IF FIO.EOF THEN
   RETURN;
   END;
  IF C="<" THEN
   ThisBuf^[ThisPnt]:="<";
   C:=FIO.RdChar(FIn);
   ThisBuf^[ThisPnt+1]:=C;
   IF C="$" THEN
    C:=FIO.RdChar(FIn);
     ThisBuf^[ThisPnt+2]:=C;
     IF C=">" THEN
      EXIT
     ELSE
      INC(ThisPnt,3);
      END;
     ELSE
      INC(ThisPnt,2);
      END;
   ELSE
   ThisBuf^[ThisPnt]:=C;
   INC(ThisPnt);
   END;
  END;
END ReadRecord;

VAR FIn,FOut : FIO.File;

PROCEDURE CheckBuffer;

CONST KillSet=CHARSET{CHR(13),CHR(10),'"',"'"," ","`","[","("};

VAR A,B : CARDINAL;

BEGIN
 IF ThisPnt #0 THEN
 FSize^[NoRec]:=ThisPnt;
 FPos^[NoRec]:=CurPos;
 IF Available(SIZE(Str70)) THEN
  NEW(Big^[NoRec]);
 ELSE
  IO.WrStr("Error : Out of memory, file to big "); IO.WrLn;
  IO.WrStr("With current (conventional) memory space ");
  IO.WrCard(NoRec,5); IO.WrStr("could've been sorted"); IO.WrLn;
  HALT;
  END;
 A:=0;
 IF ThisBuf^[A]=BYTE("!") THEN
  WHILE ThisBuf^[A]#BYTE(10) DO
   INC(A);
   END;
  INC(A);
  END;
 WHILE CHAR(ThisBuf^[A]) IN KillSet DO
  INC(A);
  END;
 B:=0;
 REPEAT
  Big^[NoRec]^[B]:=CAP(CHR(ThisBuf^[A+B]));
  INC(B);
 UNTIL (ThisBuf^[A+B]=BYTE(13)) OR (B=HiStr);
 IF B # HiStr THEN
  Big^[NoRec]^[B]:=CHR(0);
  END;
 INC(NoRec);
 IF NoRec=HiNr THEN
  IO.WrStr("Can't sort this file. File to big"); IO.WrLn;HALT;
  END;
 END;
END CheckBuffer;

PROCEDURE Dump;
VAR F3 : FIO.File;
    A:CARDINAL;
BEGIN
 F3:=FIO.Create("Dump.bak");
 FOR A:=0 TO NoRec-1 DO
  FIO.WrStr(F3,Big^[A]^); FIO.WrLn(F3);
  END;
 FIO.Close(F3);
END Dump;

PROCEDURE CookSrt(Name : ARRAY OF CHAR;SortSize :BOOLEAN;Dump1stLines:BOOLEAN);

VAR B1,B2: FBufP;

PROCEDURE CleanUp;
VAR LU : CARDINAL;

BEGIN
  FIO.Close(FIn);
  DISPOSE(ThisBuf); DISPOSE(FPos); DISPOSE(FSize);
  IF NoRec#0 THEN
   FOR LU:=0 TO NoRec-1 DO
    DISPOSE(Big^[LU]);
    END;
    END;
  DISPOSE(B1);DISPOSE(B2); DISPOSE(Big);
END CleanUp;

VAR Sort : CompareProc;
    A,B  : CARDINAL;
    T1,T2 : FIO.PathStr;

BEGIN
 NEW(ThisBuf); NEW(FPos); NEW(FSize); NEW(Big);
 NEW(B1);NEW(B2);
 StartStopWatch;
 FIn:=FIO.Open(Name);
 FIO.AssignBuffer(FIn,B1^);
 A:=CARDINAL(FIO.RdChar(FIn));
 IF A # CARDINAL("#") THEN
  IO.WrStr("No valid SRC file '"); IO.WrStr(Name);IO.WrLn;
  CleanUp;
  HALT;
  END;
 TwirMask:=63;

 IO.WrStr("Reading file : "); IO.WrStr(Name); IO.WrStr("(Grabbing every 1st line of a joke)  ");
 Twirly;

 FIO.Seek(FIn,0);
 NoRec  :=0;
 LOOP
  CurPos:=FIO.GetPos(FIn);
  ReadRecord(FIn);                      (* Read a Joke*)
  IF FIO.EOF THEN
   CheckBuffer;                          (* Append joke to buffer *)
   EXIT;                                 (* Exit LOOP *)
   END;
  CheckBuffer;
  END;
 KillTwir;
 IF SortSize THEN
  Sort:=CmpSize;
 ELSE
  Sort:=CmpName
  END;
 IO.WrLn;
 TwirMask:=2047;
 IO.WrStr("Sorting : "); IO.WrStr(Name); IO.WrStr("  ");
 IF UseQSort THEN
  QSort(NoRec,Sort,Swp);
 ELSE
  HSort(NoRec,Sort,Swp);
  END;
 KillTwir;
 IO.WrLn;
 Copy(T1,Name);
 Copy(T2,Name);
 ChangeExtension(T2,"BAK");
 ChangeExtension(T1,"TMP");
 TwirMask:=127;

 IO.WrStr("Writing file to disk  ");
 FOut:=FIO.Create(T1);
 FIO.AssignBuffer(FOut,B2^);
 FOR A := 0 TO NoRec-1 DO
  FIO.Seek(FIn,FPos^[A]);
  Twirly;
  B:=FIO.RdBin(FIn,ThisBuf^[0],FSize^[A]);
  WHILE CHAR(ThisBuf^[FSize^[A]-1]) IN Kill DO
   DEC(FSize^[A]);
   END;
  FIO.WrBin(FOut,ThisBuf^,FSize^[A]);
  IF A#(NoRec-1) THEN
   FIO.WrLn(FOut);
   FIO.WrStr(FOut,"<$>");
   END;
  END;
 KillTwir;
 FIO.Close(FOut);
 IO.WrLn;
 IF Dump1stLines THEN
  Dump;
  END;
 IO.WrStr("Renaming and cleaning up");
 CleanUp;
 IF FIO.Exists(T2) THEN
  FIO.Erase(T2);
  END;
 FIO.Rename(Name,T2);
 FIO.Rename(T1,Name);
 IO.WrLn;
 EndStopWatch;
END CookSrt;

PROCEDURE ParseSecInd(No,Max:CARDINAL):CARDINAL;

VAR IndPtr   : CARDINAL;
    LocalRec : CARDINAL;

PROCEDURE NextOneSec():BOOLEAN;

BEGIN
 LOOP
  IF Pt2^[IndPtr]=BYTE(1) THEN
   INC(IndPtr);
   RETURN FALSE;
   END;
  INC(IndPtr);
  IF IndPtr>=(Max) THEN
   RETURN TRUE;
   END;
  END;
END NextOneSec;

BEGIN
 IndPtr:=0;
  LocalRec:=0;
  LOOP
   IF LocalRec=No THEN
    EXIT
    END;
   IF NextOneSec() THEN
    EXIT
    END;
   INC(LocalRec);
   END;
  RETURN IndPtr;
END ParseSecInd;

PROCEDURE ReadTable2(HdrF:FIO.File;Search : LONGCARD;
                                     VAR DPos:LONGCARD;VAR RdNr:CARDINAL);

VAR B,
    D,C,CPos : LONGCARD;

BEGIN
 FIO.Seek(HdrF,IndTab1);
 B:=1;
 LOOP
  C:=Rd32(HdrF);
  CPos:=Rd32(HdrF);
  IF Search<C THEN
   EXIT
   END;
  D:=C;
  DPos:=CPos;
  IF B=Hdr.Table1El THEN
   EXIT
   END;
  INC(B);
  END;
 DEC(Search,D); (* Number in SET *)
 RdNr:=CARDINAL(Search);
END ReadTable2;

PROCEDURE ReadAndOutputJoke(Name :ARRAY OF CHAR;Number : CARDINAL;FPos:LONGCARD):CARDINAL;

VAR A,B   : CARDINAL;
    Recje : BaseRecord;
    Chr   : CHAR;

PROCEDURE CleanUp;

BEGIN
FIO.Close(FIn);
 DISPOSE(Pt2); DISPOSE(Pt);
END CleanUp;

BEGIN
 NEW(Pt); NEW(Pt2);
 FIn:=FIO.Open(Name);
 FIO.AssignBuffer(FIn,MainBuf2);
 FIO.Seek(FIn,FPos);
 A:=FIO.RdBin(FIn,Recje,SIZE(BaseRecord));
 IF Recje.Ident # 0FDB97531H THEN
  IO.WrStr("Invalid CAF file"); IO.WrLn;
  CleanUp;
  RETURN 1;
  END;
 IF A#SIZE(BaseRecord) THEN
  CleanUp;
  RETURN 1;
  END;
 A:=FIO.RdBin(FIn,Pt^,CARDINAL(Recje.Uncompr));
 Unpacker(CARDINAL(Recje.Uncompr),ADR(Pt^),ADR(Pt2^));
 A:=ParseSecInd(Number,CARDINAL(Recje.Uncompr));
 IO.WrLn;
 IF (Pt2^[A]=BYTE("!")) OR (Pt2^[A+1]=BYTE("!")) THEN

  INC(A);   INC(A);
  WHILE ((ORD(Pt2^[A])>47) AND(ORD(Pt2^[A])<58)) AND (A<CARDINAL(Recje.Uncompr)) DO
   INC(A);
   END;
  END;
 LOOP
  Chr:=Pt2^[A];
  IF Chr=CHR(1) THEN
   EXIT
   END;
  CASE Chr OF
   | CHR(13) : IO.WrLn;
   | CHR(2)  : IO.WrCharRep(CHR(Pt2^[A+1]),CARDINAL(Pt2^[A+2])); INC(A,2);
   | CHR(3)  : IO.WrCharRep(" ",2);
   | CHR(4)  : IO.WrCharRep(" ",3);
   | CHR(5)  : IO.WrCharRep(".",2);
   | CHR(6)  : IO.WrCharRep(" ",CARDINAL(Pt2^[A+1])); INC(A);
   | CHR(7)  : IO.WrCharRep(".",CARDINAL(Pt2^[A+1])); INC(A);
   | CHR(8)  : IO.WrLn; IO.WrLn;
   | CHR(9)  : FOR B:=1 TO CARDINAL(Pt2^[A+1]) DO
                IO.WrLn;
                END;
               INC(A);
  ELSE
   IO.WrChar(Chr);
   END;
  INC(A);
  IF A>=CARDINAL(Recje.Uncompr) THEN
   EXIT
   END;
  END;
  CleanUp;
 IO.WrLn;
 RETURN 0;
END ReadAndOutputJoke;

PROCEDURE DumInitCDX(Name:ARRAY OF CHAR;VAR HdrF:FIO.File):CARDINAL;

VAR NDXName : FIO.PathStr;
    A, Siz     : CARDINAL;

BEGIN
 NEW(Pt);
 Copy (NDXName,Name);
 ChangeExtension(NDXName,"CDX");
 HdrF:=FIO.Open(NDXName);
 FIO.AssignBuffer(HdrF,MainBuf);
 Siz:=Rd16(HdrF);
 A:=FIO.RdBin(HdrF,Pt^,Siz);
 Move(ADR(Pt^),ADR(Hdr),SIZE(HdrRecord));
 IF (Hdr.Ident # 13579BDFH) OR (Hdr.Version<102H) THEN
  FIO.Close(HdrF);
  FIO.Erase(NDXName);
  DISPOSE (Pt);
  RETURN 2;
  END;
 IndTab1:=LONGCARD(SIZE(HdrRecord)+2);
 IndTab2:=IndTab1+Hdr.Table1El*8;
 DISPOSE(Pt);
 RETURN 0;
END DumInitCDX;

PROCEDURE CountNumber(HdrF:FIO.File;CatRec : CategRec):LONGCARD;

(* Count jokes in File that match the Category setting *)

VAR A   : LONGCARD;
    Cat : CARDINAL;
    Lev : CARDINAL;
    TotR : LONGCARD;

BEGIN
 TotR:=0;
 FIO.Seek(HdrF,IndTab2);
 FOR A:=1 TO Hdr.TotalCRec DO
  Cat:=CARDINAL(FIO.RdChar(HdrF));
  Lev:=CARDINAL(FIO.RdChar(HdrF));
  IF (Lev<=CARDINAL(CatRec.High[Cat])) AND (Lev>=CARDINAL(CatRec.Low[Cat])) THEN
   INC(TotR);
   END;
  END;
  RETURN TotR;
END CountNumber;

PROCEDURE Count2RecNr (HdrF:FIO.File;CatRec : CategRec;Target:LONGCARD):LONGCARD;

 VAR A   : LONGCARD;
    Cat : CARDINAL;
    Lev : CARDINAL;
    TotR : LONGCARD;

BEGIN
 TotR:=0; A:=0;
 INC(Target);
 FIO.Seek(HdrF,IndTab2);
 LOOP
  Cat:=CARDINAL(FIO.RdChar(HdrF));
  Lev:=CARDINAL(FIO.RdChar(HdrF));
  IF (Lev<=CARDINAL(CatRec.High[Cat])) AND (Lev>=CARDINAL(CatRec.Low[Cat])) THEN
   INC(TotR);                    (* Count allowed record *)
   END;

  IF TotR=Target THEN
   RETURN A;
   END;
  INC(A);                        (* Count all records*)
  IF A=Hdr.TotalCRec THEN
   EXIT
   END;
  END;
 RETURN MAX(LONGCARD);
END Count2RecNr;

PROCEDURE MakeInf(Name : ARRAY OF CHAR);

VAR FIn,
    FHdr,
    FOut,
    FCens      : FIO.File;
    Rec         : BaseRecord;
    TotalByte,
    TotalRec    : LONGCARD;
    TotalCRec   : LONGCARD;
    A           : CARDINAL;

PROCEDURE CopyFile(S :ARRAY OF CHAR);

BEGIN
 FOut:=FIO.Open(S);
 LOOP
  A:=FIO.RdBin(FOut,Pt^,32768);
  IF A # 0 THEN
   FIO.WrBin(FHdr,Pt^,A);
   END;
  IF A<32768 THEN
   EXIT
   END;
  END;
 FIO.Close(FOut);
 FIO.Erase(S);
END CopyFile;

PROCEDURE ParseInd;

VAR IndPtr   : CARDINAL;
    LocalRec : CARDINAL;

PROCEDURE PutMark;

VAR U,U2 : CARDINAL;
BEGIN
  IF Pt2^[IndPtr]=BYTE("!") THEN
   U:=ORD(CAP(CHAR(Pt2^[IndPtr+1])))-64;
     U2:=ORD(Pt2^[IndPtr+2]);
     IF (U2>47) AND (U2<56) THEN
      INC(U,(U2-48)<<8);
     ELSE
      INC(U,9*256);
      END;
    ELSIF Pt2^[IndPtr]=BYTE("#") THEN
     U:=CommentValue+256;
    ELSE
     U:=0;
    END;
   INC(TotalCRec);
   Wr16(FCens,U);
END PutMark;

PROCEDURE NextOne(EndVal:CARDINAL):BOOLEAN;

BEGIN
 LOOP
  IF Pt2^[IndPtr]=BYTE(1) THEN
   INC(IndPtr);
   PutMark;
   RETURN FALSE;
   END;
  INC(IndPtr);
  IF IndPtr>=EndVal THEN
   RETURN TRUE;
   END;
  END;
END NextOne;

BEGIN
  IndPtr:=0;
  LocalRec:=0;
  PutMark;
  IndPtr:=0;
  LOOP
   IF NextOne(CARDINAL(Rec.Uncompr)-2) THEN
    EXIT
    END;
   INC(LocalRec);
   END;
END ParseInd;

VAR
    Set : LONGCARD;
    NdxName : FIO.PathStr;

BEGIN
 NEW(Pt); NEW(Pt2);
 Copy (NdxName,Name);
 ChangeExtension(NdxName,"CDX");
 FIn:=FIO.Open(Name);
 FHdr:=FIO.Create(NdxName);
 FIO.WrBin(FHdr,Pt2^,SIZE(HdrRecord)+2); (* Temporary garbadge, to eat up
                                             the space, corrected lateron *)
 FCens:=FIO.Create("tmp2.tmp");
 Set:=0;
 TotalRec:=0;  TotalByte:=0; TotalCRec:=0;
 LOOP
  A:=FIO.RdBin(FIn,Rec,SIZE(Rec));
  IF A<SIZE(Rec) THEN
   EXIT
   END;
  IF Rec.Ident # 0FDB97531H THEN
   DISPOSE(Pt); DISPOSE(Pt2);
   FIO.Close(FIn);
   FIO.Close(FHdr);
   FIO.Erase(NdxName);
   FIO.Erase("TMP2.TMP");
   IO.WrStr("Invalid CAF file, or no CAF file");
   HALT;
   END;
  Wr32 (FHdr,TotalRec);
  Wr32 (FHdr,FIO.GetPos(FIn)-SIZE(Rec));
  INC(Set);
  IF NOT NoOutput THEN
   IO.WrStr("Indexing set"); IO.WrLngCard(Set,0); IO.WrStr(" : ");
   IO.WrCard(Rec.NoRec,5); IO.WrStr(" Jokes");
   IO.WrLngCard(Rec.Compr,6); IO.WrStr(" bytes compr.");
   IO.WrLngCard(Rec.Uncompr,6); IO.WrStr(" bytes uncompr.");
   IO.WrLn;
   END;
  A:=FIO.RdBin(FIn,Pt^,CARDINAL(Rec.Compr));
  IF A # CARDINAL(Rec.Compr) THEN
   IO.WrStr("Archive is broken!"); HALT;
   END;
  Unpacker(CARDINAL(Rec.Uncompr),ADR(Pt^),ADR(Pt2^));
  A:=CARDINAL(Rec.Uncompr)-1;
  WHILE Pt2^[A]=BYTE(1) DO
   Pt2^[A]:=CHR(32);
   DEC (A);
   END;
  Rec.Uncompr:=LONGCARD(A);
  ParseInd;
  INC(TotalRec,LONGCARD(Rec.NoRec));
  INC(TotalByte,LONGCARD(Rec.Uncompr));
  END;
 FIO.Close(FIn);
 FIO.Close(FCens);
 CopyFile("tmp2.tmp");
 Hdr.TotalRec:=TotalRec;
 Hdr.Table1El:=Set;
 Hdr.Version:=102H;             (* Version 1.02 header *)
 Hdr.Ident:=13579BDFH;
 Hdr.TotalCRec:=TotalCRec;
 FIO.Seek(FHdr,0);
 Wr16(FHdr,SIZE(HdrRecord));
 FIO.WrBin(FHdr,Hdr,SIZE(HdrRecord));
 FIO.Close(FHdr);
 IF NOT NoOutput THEN
  IO.WrLn;
  IO.WrStr("Total jokes : "); IO.WrLngCard(TotalRec,0); IO.WrStr(" : ");
  IO.WrLngCard(TotalByte,0); IO.WrStr(" bytes uncompressed.");
  IO.WrLn;
  END;
 DISPOSE(Pt); DISPOSE(Pt2);
END MakeInf;

PROCEDURE InitCDX (Name:ARRAY OF CHAR;VAR HdrF:FIO.File):CARDINAL;

VAR Dum : CARDINAL;

BEGIN
 Dum:=DumInitCDX(Name,HdrF);
 IF Dum=2 THEN
  MakeInf(Name);
  Dum:=DumInitCDX(Name,HdrF);
  END;
 RETURN Dum;
END InitCDX;


PROCEDURE CheckForRebuild(Name : ARRAY OF CHAR;AutoReb:BOOLEAN);
VAR   Rebuild         : BOOLEAN;
      Path            : FIO.PathStr;

BEGIN
   Rebuild:=AutoReb;
   Copy(Path,Name);
   ChangeExtension(Path,"CDX");
   IF NOT NoOutput THEN
    IO.WrStr("Checking the index : "); IO.WrStr(Path); IO.WrLn; IO.WrLn;
    END;
   IF FIO.Exists(Path) THEN
    IF FDate(Path)<FDate(Name) THEN
     Rebuild:=TRUE;
     END;
    ELSE
     Rebuild:=TRUE;
     END;
    IF Rebuild THEN
     IF NOT NoOutput THEN
      IO.WrStr("Rebuilding : "); IO.WrStr(Path); IO.WrLn; IO.WrLn;
      END;
     MakeInf(Name);
     END;
END CheckForRebuild;

PROCEDURE DoConfigLine(VAR Toto : ARRAY OF CHAR;VAR CatRec:CategRec);

CONST Limitset=CHARSET{"0".."9","-"};

VAR S : ARRAY [0..100] OF CHAR;
    A,B,Hi,Lo  : CARDINAL;

BEGIN
 A:=0;
 LOOP
  ItemS(S,Toto," ",A);
  IF S[0]=CHR(0) THEN
   EXIT
   END;
  Lo:=0; Hi:=10;
  B:=ORD(S[0])-64;
  IF NOT (S[1] IN Limitset) THEN
   Lo:=10; Hi:=10;
  ELSE
    IF S[1]="-" THEN
     Lo:=ORD(S[2])-48;
    ELSE
     IF S[2]="-" THEN
      Hi:=ORD(S[1])-48;
      IF (ORD(S[3])>47) AND (ORD(S[3])<58) THEN
       Lo:=ORD(S[3])-48;
       END;
      END;
     END;
   END; (* NOT S[1] *)
  CatRec.Low[B]:=BYTE(Lo);
  CatRec.High[B]:=BYTE(Hi);
  INC(A);
  END;
END DoConfigLine;

BEGIN
 NoOutput:=TRUE;  (* Default no-output (Cookie), CookComp sets this to true*)
 UseQSort:=FALSE; (* QSort is faster with not sorted arrays, HSort is faster
                     with almost sorted arrays*)
 TwirMask:=127;   (* Speed of Twirly, once in TwirMask+1 runs.
                     MUST BE 2^X-1 !!! *)
END CookShr.