MODULE Label2;
(* Used to 4dos-describe .LIBs quickly. Written at a time, I expected
to get many libs. *)

IMPORT FIO,Str,IO,Storage,Lib,ELib;

TYPE BufType = ARRAY[0..10000] OF BYTE;
     BufPtr  = POINTER TO BufType;

VAR D : FIO.DirEntry;
    Fl:BOOLEAN;
    F : FIO.File;
    S : ARRAY[0..100] OF CHAR;
    Buf : BufPtr;
    L  : CARDINAL;

PROCEDURE DoName();

BEGIN
 Str.Copy(S,D.Name);
 ELib.RGrow(S," ",20);
 Str.Append(S," ");
 Str.Caps(D.Name);
 CASE D.Name[0] OF
  | "R" : Str.Append(S,"DOS ");
  | "W" : Str.Append(S,"WIN ");
  | "P" : Str.Append(S,"OS2 ");
  END;
 IF D.Name[0] IN Str.CHARSET{"R","W","P"} THEN
  CASE D.Name[1] OF
   | "S"  : Str.Append(S,"Small   ");
   | "C"  : Str.Append(S,"Compact ");
   | "M"  : Str.Append(S,"Medium  ");
   | "L"  : Str.Append(S,"Large   ");
   | "X"  : Str.Append(S,"XLarge  ");
   | "T"  : Str.Append(S,"Mthread ");
   | "O"  : Str.Append(S,"Overlay ");
   | "D"  : Str.Append(S,"Dynalnk ");
   END;
  CASE D.Name[2] OF
   | "_"  : Str.Append(S,"JPI   ");
   | "F"  : Str.Append(S,"Stack ");
   END;
  END;
 Lib.Move(ADR(S),ADR(Buf^[L]),Str.Length(S));
 INC(L,Str.Length(S));
 Buf^[L]:=CHR(13);
 Buf^[L+1]:=CHR(10);
 INC(L,2);
END DoName;

BEGIN
 Storage.ALLOCATE(Buf,SIZE(BufType));
 L:=0;
 F:=FIO.Create("out.des");
 Fl:=FIO.ReadFirstEntry("*.lib",FIO.FileAttr{},D);
 DoName;
 WHILE Fl DO
  Fl:=FIO.ReadNextEntry(D);
  IO.WrStr(D.Name);
  IO.WrLn;
  DoName;
  END;
 FIO.WrBin(F,Buf^,L+1);
 FIO.Close(F);
END Label2.