MODULE CrtDemo;
(*
General Crt module demo (XtdLib package), (C) by Marco van de Voort 1996
   VGA only!!.

Watch out, the const WeirdMode is a modenumber that is adapter specific.
It sets my Trident in 120x60 mode. Adapt to a value specific for your own
adapter.

*)

FROM Crt IMPORT TextColor,TextBackground,Color,BlinkOff,ClrScr,
                GotoXY,ScrDat,ConvertMode,Detect,ClrEol,InsLine,DelLine,
                ClrVLine,Magenta,DoScreen;
FROM IO  IMPORT WrStr,WrCard,KeyPressed,WrLn,RdKey;
FROM Lib IMPORT RANDOM,RANDOMIZE;

CONST WeirdMode=86;                       (* <------------ Watch out,
                                             vga-adapter specific *)

PROCEDURE Empty; (* Empty keyboard buffer *)

VAR C : CARDINAL;

BEGIN
 WHILE KeyPressed() DO
  C:=ORD(RdKey());
  END;
END Empty;

PROCEDURE Key;

BEGIN
 WHILE NOT KeyPressed() DO
  END;
END Key;

VAR A,B   : CARDINAL;

BEGIN
 Detect;
 RANDOMIZE;
 ClrScr;
 BlinkOff;
 WHILE NOT KeyPressed() DO
  INC(A);
  TextColor(Color(A MOD 15));
  TextBackground(Color((A+1) MOD 15));
  WrStr("WrapTst");
  END;
 Empty;
 TextBackground(Color(0));
 ClrScr;
 FOR A:=0 TO 35 DO
  TextBackground(Color(0));
  TextColor(Color(A MOD 15));
  WrStr(" This is a wrap test but it tests WrCard too!  :");
  WrCard(A,5);
  WrLn;
  END;
 Key; Empty;
 TextBackground(Color(1));
 TextColor(Color(15));
 ClrScr;
 TextBackground(Color(6));
 TextColor(Color(10));
 FOR A:=0 TO ScrDat.Depth DO
  GotoXY(70,A);
  WrCard(A,6);
  END;
 GotoXY(10,10);
 ClrEol;
 WrStr("Fully functional ClrEol.");
 GotoXY(10,13);
 InsLine;
 WrStr("Fully functional Insert Line.");
 Key; Empty;
 GotoXY(10,15);
 DelLine;
 WrStr("DelLine works too.");
 Key; Empty;
 TextBackground(Magenta);
 GotoXY(5,3);
 ClrVLine;
 GotoXY(7,3);
 TextBackground(Color(6));
 WrStr("Vertical column erase with ClrVLine");

 Key; Empty;
 WHILE NOT KeyPressed() DO
  GotoXY(RANDOM(ScrDat.Width-11),RANDOM(ScrDat.Depth+1));
  TextColor(Color(RANDOM(15)));
  TextBackground(Color(RANDOM(15)));
  WrStr("GotoXY test");
  END;
 Empty;
 GotoXY(0,0);
 B:=((ScrDat.Depth+1)*ScrDat.Width);
 IF (B MOD 11) =0 THEN
  B:=(B DIV 11) -2;
 ELSE
  B:=(B DIV 11) -1;
  END;
 FOR A:=0 TO B DO
  TextColor(Color(RANDOM(15)));
  TextBackground(Color(RANDOM(15)));
  WrStr("WrapperTest");
  END;
 FOR A:=0 TO ScrDat.Depth DO
  GotoXY(A,A);
  WrStr("   This is a test too !    ");
  END;
 Key;
 Empty;
 TextBackground(Color(8));
 ConvertMode(WeirdMode);
 BlinkOff;
 Key;
 Empty;
 DoScreen;
 ConvertMode(3);
 BlinkOff;
END CrtDemo.