MODULE Cvt;
(* belongs to FontEditor. Puts some data in front of a normal bitmapped fontfile,
   allowing FontEditor to pick the right resolution. Use only with 8x16 fonts

  (C) None, since this module was written in less than one minute :-)   *)

IMPORT FIO,Lib,Str,IO,ELib;

VAR S1        : ARRAY[0..99] OF CHAR;
    Buf       : ARRAY[0..4095] OF BYTE;
    VAR F1,F2 : FIO.File;
    A         : CARDINAL;
    Fl        : BOOLEAN;
    FD        : FIO.DirEntry;


BEGIN
 IF Lib.ParamCount()>0 THEN
  Lib.ParamStr(S1,1);
 ELSE
  HALT;
  END;
 Fl:=FIO.ReadFirstEntry(S1,FIO.FileAttr{},FD);
 LOOP
  IF NOT Fl THEN
   EXIT
   END;
  Str.Copy(S1,FD.Name);
  ELib.ChangeExtension(S1,"FT");
  F1:=FIO.Open(FD.Name);
  F2:=FIO.Create(S1);
  FIO.WrChar(F2,CHR(8));
  FIO.WrChar(F2,CHR(16));
  FIO.WrChar(F2,CHR(0));
  FIO.WrChar(F2,CHR(1));
  A:=FIO.RdBin(F1,Buf,4096);
  LOOP
   FIO.WrBin(F2,Buf,A);
   IF A<4096 THEN
    EXIT
    END;
   A:=FIO.RdBin(F1,Buf,4096);
   END;
  FIO.Close(F1);
  FIO.Close(F2);
  Fl:=FIO.ReadNextEntry(FD);
  END;

END Cvt.