IMPLEMENTATION MODULE QuoLocal;

FROM Window  IMPORT GotoXY,TextColor,Color,DoubleFrame;
FROM IO      IMPORT WrStr,WrCharRep,WrCard;
FROM WinProc IMPORT BuildScreenFromPtr,InputStr,SetAttrs,InBigPtr,GetStrPtr,
                    SelectEditRec,EditRec,EditArray,Toggler,YesNo,EditRecord;
FROM Lib     IMPORT Move,Fill;
FROM ELib    IMPORT CardToS,SToCard;
FROM Str     IMPORT CHARSET,Length;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;


PROCEDURE GetNumber(X,Y,Len1,Len2:CARDINAL;VAR Erin:CARDINAL);

VAR     DStr:ARRAY[0..20] OF CHAR;
        Fl  : BOOLEAN;

BEGIN
 Fl:=FALSE;
 REPEAT
  Fl:=CardToS(Erin,DStr);
  Fl:=InputStr(DStr,X+Len2,Y,Len1,TRUE,Cyfer);
  Erin:=SToCard(DStr,Fl);
 UNTIL Fl;
END GetNumber;

PROCEDURE LocalArrEditBackGr;
BEGIN
 GotoXY(5,1);
 TextColor(Yellow);
 WrStr("Country Tag"); GotoXY(40,1); WrStr("TelNr");
END LocalArrEditBackGr;

PROCEDURE LocalOtherArrKeys(Key :CARDINAL;VAR CRec,NrRec : CARDINAL);

VAR A,B :CARDINAL;

  CONST   F1  = 3B00H;

BEGIN
 CASE Key OF
  | F1     :  IF NrRec >1 THEN
              (* ReSort( NrRec );*)
               CRec:=1;
               END;
  END;
END LocalOtherArrKeys;


PROCEDURE LocalArrEditDisplay(Nr,Y:CARDINAL;Col:BYTE);

BEGIN
 SetAttrs(Col);
 GotoXY(5,Y+2);
 WrCharRep(" ",60);
 GotoXY(5,Y+2);
 WrStr(LocalArr^[Nr].Descr);
 GotoXY(40,Y+2);
 WrCard(LocalArr^[Nr].MainNum,-5);
END LocalArrEditDisplay;

PROCEDURE LocalDelRecPr(VAR Y,Nr:CARDINAL);

BEGIN
 IF Nr=1 THEN
  Nr:=0;
 ELSIF (Nr>1) AND (Y=Nr) THEN
  DEC(Nr);
  DEC(Y);
 ELSIF Nr>1 THEN
  Move(ADR(LocalArr^[Nr]),ADR(LocalArr^[Y]),SIZE(LocalRec));
  DEC(Nr);
  END;
END LocalDelRecPr;

PROCEDURE LocalInsRecPr(VAR Y,Nr:CARDINAL);

BEGIN
 INC(Nr);
 Fill(ADR(LocalArr^[Nr]),SIZE(LocalRec),0);
END LocalInsRecPr;

(* Edit Record procedures *)

PROCEDURE LocalEditRBackGr;

BEGIN
 BuildScreenFromPtr(TSLocal);
END LocalEditRBackGr;

PROCEDURE LocalEditF(Field,Rec :CARDINAL);

VAR
    Fl        : BOOLEAN;
    X,Y,
    Len1,Len2 : CARDINAL;
    L         : InBigPtr;

BEGIN
 L:=GetStrPtr(TSLocal,Field-1);
 X:=ORD(L^[0]); Y:=ORD(L^[1]); Len1:=ORD(L^[2]); Len2:=Length(L^)-3;
 GotoXY(X+Len2,Y);
 CASE Field OF
  |1  : Fl:=InputStr(LocalArr^[Rec].Descr,X+Len2,Y,Len1,TRUE,AlfaBeta);
  |2  : GetNumber(X,Y,Len1,Len2,LocalArr^[Rec].MainNum);
  |3..14: GetNumber(X,Y,Len1,Len2,LocalArr^[Rec].LocalNums[Field-3]);

 END;
END LocalEditF;

PROCEDURE LocalDisplF(Y2: CARDINAL;NrRec:CARDINAL;Col:BYTE);

VAR Ch,
    Fl : BOOLEAN;
    A,X,Y,
    Len1,Len2 : CARDINAL;
    L : InBigPtr;

BEGIN
 L:=GetStrPtr(TSLocal,Y2-1);
 X:=ORD(L^[0]); Y:=ORD(L^[1]); Len1:=ORD(L^[2]); Len2:=Length(L^)-3;
 GotoXY(X+Len2,Y);
 SetAttrs(Col);
 WrCharRep(" ",Len1);
 GotoXY(X+Len2,Y);
 CASE Y2 OF
  |1  : WrStr(LocalArr^[NrRec].Descr);
  |2  : WrCard(LocalArr^[NrRec].MainNum,-5);
  |3..14 :  WrCard(LocalArr^[NrRec].LocalNums[Y2-3],-INTEGER(Len1));
   END;
END LocalDisplF;

CONST EditArr=SelectEditRec(5,5,60,20,TRUE,DoubleFrame,LightCyan,Black,Black,White,
               LocalArrEditBackGr,LocalArrEditDisplay,LocalDelRecPr,LocalInsRecPr,LocalOtherArrKeys,14,12,HIGH(LocalArr^));

      EditR=EditRec(LocalEditF,LocalEditRBackGr,LocalDisplF,4,5,70,20,TRUE,DoubleFrame,LightCyan,Black,Black,Yellow);

PROCEDURE LocalEdit;

VAR OO            : POINTER TO SelectEditRec;
    EE            : POINTER TO EditRec;

BEGIN
  NEW(OO); NEW(EE);
  OO^:=EditArr; EE^:=EditR;
  EditArray(OO^,EE^,TotalLocalRec);
  DISPOSE(OO); DISPOSE(EE);
END LocalEdit;

(* --------------------- Main Information Record----------------------- *)

PROCEDURE MainEditRBackGr;

BEGIN
 BuildScreenFromPtr(TSMainRec);
END MainEditRBackGr;

CONST MailerToggle=CHR(4)+"Intermail@Xenia@FrontDoor@MainDoor";
      OutputToggle=CHR(3)+"ANSI@LOWASCII@HIGHASCII";
      SecTikToggle=CHR(2)+"Seconds@Ticks";

PROCEDURE MainEditF(Field,Rec :CARDINAL);

VAR
    Fl        : BOOLEAN;
    X,Y,
    Len1,Len2 : CARDINAL;
    L         : InBigPtr;

BEGIN
 L:=GetStrPtr(TSMainRec,Field-1);
 X:=ORD(L^[0]); Y:=ORD(L^[1]); Len1:=ORD(L^[2]); Len2:=Length(L^)-3;
 GotoXY(X+Len2,Y);
 CASE Field OF
  |1  : Toggler(MainRec.Mailer,MailerToggle,TRUE);
  |2  : Fl:=InputStr(MainRec.FDplace,X+Len2,Y,Len1,TRUE,AlfaBeta);
  |3  : Toggler(MainRec.OutputType,OutputToggle,TRUE);
  |4  : GetNumber(X,Y,Len1,Len2,MainRec.CostCallLocal);
  |5  : Toggler(MainRec.LocalRound,YesNo,TRUE);
  |6  : GetNumber(X,Y,Len1,Len2,MainRec.CostCallInter);
  |7  : Toggler(MainRec.InterRound,YesNo,TRUE);
  |8  : GetNumber(X,Y,Len1,Len2,MainRec.AreaNumber);
  |9  : Toggler(MainRec.SecondOrTick,SecTikToggle,TRUE);
  |10 : GetNumber(X,Y,Len1,Len2,MainRec.HighTarifLow);
  |11 : GetNumber(X,Y,Len1,Len2,MainRec.HighTarifHigh);
  |12 : GetNumber(X,Y,Len1,Len2,MainRec.TickexpensInter);
  |13 : GetNumber(X,Y,Len1,Len2,MainRec.TickexpensLocal);
  |14 : GetNumber(X,Y,Len1,Len2,MainRec.TickcheapInter);
  |15 : GetNumber(X,Y,Len1,Len2,MainRec.TickcheapLocal);

 END;
END MainEditF;

PROCEDURE MainDisplF(Y2: CARDINAL;NrRec:CARDINAL;Col:BYTE);

VAR Ch,
    Fl : BOOLEAN;
    A,X,Y,
    Len1,Len2 : CARDINAL;
    L : InBigPtr;

BEGIN
 L:=GetStrPtr(TSMainRec,Y2-1);
 X:=ORD(L^[0]); Y:=ORD(L^[1]); Len1:=ORD(L^[2]); Len2:=Length(L^)-3;
 GotoXY(X+Len2,Y);
 SetAttrs(Col);
 WrCharRep(" ",Len1);
 GotoXY(X+Len2,Y);
 CASE Y2 OF
  |1  : Toggler(MainRec.Mailer,MailerToggle,FALSE);
  |2  : WrStr(MainRec.FDplace);
  |3  : Toggler(MainRec.OutputType,OutputToggle,FALSE);
  |4  : WrCard(MainRec.CostCallLocal,-INTEGER(Len1));
  |5  : Toggler(MainRec.LocalRound,YesNo,FALSE);
  |6  : WrCard(MainRec.CostCallInter,-INTEGER(Len1));
  |7  : Toggler(MainRec.InterRound,YesNo,FALSE);
  |8  : WrCard(MainRec.AreaNumber,-INTEGER(Len1));
  |9  : Toggler(MainRec.SecondOrTick,SecTikToggle,FALSE);
  |10 : WrCard(MainRec.HighTarifLow,-INTEGER(Len1));
  |11 : WrCard(MainRec.HighTarifHigh,-INTEGER(Len1));
  |12 : WrCard(MainRec.TickexpensInter,-INTEGER(Len1));
  |13 : WrCard(MainRec.TickexpensLocal,-INTEGER(Len1));
  |14 : WrCard(MainRec.TickcheapInter,-INTEGER(Len1));
  |15 : WrCard(MainRec.TickcheapLocal,-INTEGER(Len1));
  END;
END MainDisplF;

CONST

      MainEditR=EditRec(MainEditF,MainEditRBackGr,MainDisplF,4,5,70,22,TRUE,DoubleFrame,LightCyan,Black,Black,Yellow);

PROCEDURE MainEditProc;


VAR
    EE            : POINTER TO EditRec;

BEGIN
  NEW(EE);
  EE^:=MainEditR;
  EditRecord(EE^,15,1);
  DISPOSE(EE);
END MainEditProc;

END QuoLocal.